//=========================================================
//
// irQ[V{^ij
//
// uցvuOցv̖{^
//
//=========================================================

#include <SFML\Window.hpp>

#include "Button.h"

//=========================================================
// RXgN^
//=========================================================
Button::Button( string imageFile ) {

	_texture.loadFromFile ( imageFile );
	_sprite.setTexture    ( _texture  );
	_sprite.setOrigin     ( _texture.getSize().x / 2.0f, _texture.getSize().y / 2.0f );
	_sprite.setColor      ( sf::Color ( 255,255,255,0 ) );

	_isMouseOver     = false;
	_isMousePressing = false;
	_isMouseRelease  = false;
}

//=========================================================
// fXgN^
//=========================================================
Button::~Button() {
	// Ȃ
}

//=========================================================
// `
//=========================================================
void Button::Draw ( sf::RenderWindow &window ) {

	///// }EẌʒu߂
	int mouseX = sf::Mouse::getPosition ( window ).x;
	int mouseY = sf::Mouse::getPosition ( window ).y;

	///// }EẌʒutXN[Ήɕϊ
	sf::Vector2f pos = window.mapPixelToCoords ( sf::Vector2i(mouseX, mouseY) );
	mouseX = pos.x;
	mouseY = pos.y;

	_isMouseRelease = false;

	///// }EXĂ
	if ( _sprite.getGlobalBounds().contains(mouseX, mouseY) ) {

		_isMouseOver = true;

		///// }EXĂ
		if ( sf::Mouse::isButtonPressed ( sf::Mouse::Button::Left ) ) {

			_isMousePressing = true;
		
		///// }EXĂȂ
		} else {

			///// O͉ĂH
			if ( _isMousePressing ) {

				///// }EX𗣂
				_isMouseRelease = true;
			}

			_isMousePressing = false;
		}

		// XɎp
		sf::Color color = _sprite.getColor();
		int alpha = color.a;
		alpha += 8;
		if ( alpha >= 255 ) {
			alpha = 255;
		}
		color.a = alpha;
		_sprite.setColor ( color );


	///// }EXĂȂ
	} else {
		_isMousePressing = false;

		// XɎp
		sf::Color color = _sprite.getColor();
		int alpha = color.a;
		alpha -= 8;
		if ( alpha < 0 ) {
			alpha = 0;
		}
		color.a = alpha;
		_sprite.setColor ( color );

	}

	window.draw ( _sprite );

}

//=========================================================
// ʒuZbg
//=========================================================
void Button::SetPosition ( sf::Vector2f pos ) {

	_sprite.setPosition ( pos );
}

//=========================================================
// NbNĂ܂H
//=========================================================
bool Button::IsClick() {

	return _isMouseRelease;
}


