//=========================================================
//
// AP[^H
//
//=========================================================

#ifndef _ALLOCATOR_
#define _ALLOCATOR_

#include <set>
using namespace std;

template <class T>
class Allocator {

public:
	//=========================================================
	// RXgN^
	//=========================================================
	Allocator() {
		_memoryPool      = NULL;
		_numberOfObjects_Current = 0;
		_numberOfObjects_Limit   = 0;
	}
	//=========================================================
	// fXgN^
	//=========================================================
	~Allocator() {

		delete _memoryPool;

		set<char*>::iterator it;
		while ( !_oldMemoryPools.empty() ) {
			it = _oldMemoryPools.begin();
			delete *(it);
			_oldMemoryPools.erase( it );
		}
	}



	//=========================================================
	// p
	//=========================================================
	void Alloc(int objectNum) {

		_stride = sizeof(T);

		_memoryPool = new char[ sizeof(T) * objectNum ];

		memset ( _memoryPool, NULL, sizeof(T) * objectNum );

		/*
		try {
			_memoryPool = new char[ sizeof(T) * objectNum ];
		} catch (bad_alloc) {
			printf("bad_alloc \n");
		} catch (...) {
			printf("̗̑O\n\n");
		}
		printf( "_memoryPool : %d \n ", _memoryPool );
		printf( "_memoryPool : %p \n ", _memoryPool );
		*/
		_numberOfObjects_Limit = objectNum;
	
	}
	//=========================================================
	// ړẴNX̃CX^X擾
	//=========================================================
	T* GenerateObj() { 

		T *result = NULL;

		// pӂtɂȂĂ
		if ( _numberOfObjects_Current >= _numberOfObjects_Limit ) {

			printf(" current : %d,  Limit :  %d\n", _numberOfObjects_Current, _numberOfObjects_Limit);

			_oldMemoryPools.insert( _memoryPool );
			_memoryPool = new char[ sizeof(T) * _numberOfObjects_Limit ];
			memset ( _memoryPool, NULL, sizeof(T) * _numberOfObjects_Limit );

			_numberOfObjects_Current = 0;

			//char *newMemoryPool = _memoryPool + (sizeof(T) * (_numberOfObjects_Current + 1));
			//newMemoryPool = new char[ sizeof(T) * _stride ];
			//_numberOfObjects_Limit += _stride;
		}

		result = new( _memoryPool +  (sizeof(T) * _numberOfObjects_Current) ) T();
		++_numberOfObjects_Current;

		return result; 
	}



private:

	char *_memoryPool;
	set<char*> _oldMemoryPools;
	int _numberOfObjects_Current;
	int _numberOfObjects_Limit;

	int _stride; // Ɋmۂ郁B

};
#endif