//=========================================================
//
// fBNg}l[W[ij
//
// uցvuOցv̑\ɂ@\B
// ǂݍݒ̃fBNg
// fBNg̉摜t@CXgB
//
//=========================================================

#include "DirManager.h"

#include "../Utils/Utils_String.h"
#include "../Utils/Utils_File.h"
#include "../Utils/Utils_Others.h"

//=========================================================
// RXgN^
//=========================================================
DirManager::DirManager() {

	_currentDirName = "";  // ݂̃fBNg
	_fileNameList.clear(); // 摜t@C̃Xg
	_currentIndex = -1;    // ݂̉摜̃CfbNX


	///// 摜ƂĔF邱ƂɂgqBSFML ͑̌`ɂΉĂ͂B
	_imageExtensionList.push_back ( "png" );
	_imageExtensionList.push_back ( "jpg" );
	_imageExtensionList.push_back ( "jpeg" );
	_imageExtensionList.push_back ( "gif" );
	_imageExtensionList.push_back ( "bmp" );
	_imageExtensionList.push_back ( "PNG" );
	_imageExtensionList.push_back ( "JPG" );
	_imageExtensionList.push_back ( "JPEG" );
	_imageExtensionList.push_back ( "GIF" );
	_imageExtensionList.push_back ( "BMP" );
}
//=========================================================
// fXgN^
//=========================================================
DirManager::~DirManager() {
	// Ȃ
}

//=========================================================
// t@Chbvꂽ
//=========================================================
void DirManager::Drop ( string path ) {

	printf ("hbvʒmF%s\n", path.c_str());

	_fileNameList.clear();
	_currentDirName = "";
	_currentIndex = -1;

	vector<string> pathList = Utils_String::Split ( path, "\\" );

	///// Ō̗vfAt@CƂ
	string dropFileName = "";
	dropFileName = pathList[ pathList.size() - 1 ];

	///// Ō̗vf𔲂AtH_ƂB
	for ( unsigned int i = 0; i < pathList.size() -1; ++i ) {

		if ( i > 0 ) {
			_currentDirName += "\\";
		}

		_currentDirName += pathList[i];
	}

	///// ̃tH_Ɋ܂܂摜Xg擾
	vector<string> fileList = Utils_File::GetFileList_nosub ( _currentDirName );

	for ( unsigned int i = 0; i < fileList.size(); ++i ) {

		// gq擾
		string extension = Utils_File::GetExtension ( fileList[i] );

		// 摜t@CAXgɓ
		if ( UTILS_OTHERS::indexOf<string> ( _imageExtensionList, extension ) != -1) {

			_fileNameList.push_back ( fileList[i] );

			printf ("摜F%s\n", fileList[i].c_str());

		}
	}


	///// hbvt@C̓Xg̒̉ԖځH
	_currentIndex = -1;
	for ( unsigned int i = 0; i < _fileNameList.size(); ++i) {

		if ( _fileNameList[i] == dropFileName ) {

			_currentIndex = i;
			break;
		}
	}

	///// ȃt@CłB
	if ( _currentIndex == -1 ) {
		_fileNameList.clear();
		_currentDirName = "";
	}
}

//=========================================================
// ̉摜
//=========================================================
void DirManager::Next() {

	if ( _fileNameList.size() > 0 ) {

		++_currentIndex;

		if ( _currentIndex >= _fileNameList.size() ) {
			_currentIndex = 0;
		}

	}
}

//=========================================================
// Ỏ摜
//=========================================================
void DirManager::Prev() {

	if ( _fileNameList.size() > 0 ) {

		--_currentIndex;

		if ( _currentIndex < 0 ) {
			_currentIndex = _fileNameList.size() - 1;
		}

	}
}

//=========================================================
// ݂̃CfbNX̉摜t@CpX擾
//=========================================================
string DirManager::GetCurrentImageFilePath () {

	string result = "";

	if ( _fileNameList.size() > 0 ) {

		if ( _currentIndex < _fileNameList.size() ) {

			result = _currentDirName + "\\" + _fileNameList [ _currentIndex ];
		}
	}

	return result;
}
//=========================================================
// ݂̃CfbNX̃t@C擾
//=========================================================
string DirManager::GetCurrentImageFileName () {

	string result = "";

	if ( _fileNameList.size() > 0 ) {

		if ( _currentIndex < _fileNameList.size() ) {

			result = _fileNameList [ _currentIndex ];
		}
	}

	return result;
}
