//=========================================================
//
// ȈXMLp[T[NXij
//
//=========================================================

#include "StdAfx.h"
#include "NotXML.h"

#include <stdio.h>

#include <fstream>

#include <vector>
#include <stack>

using namespace std;


//=========================================================
// ǂݍ
//=========================================================
vector<NotXML::Tag> NotXML::Read(string fileName) {

	// ߂lƂȂϐp
	vector<Tag> result;

	// w肳ꂽt@CǂݍŁAg string^Ŏ
	string fileContent = ReadFile_toString( fileName );

	// u<vu>vň͂ꂽvf̃Xgo
	vector<string> pureTagList = Parse_PureTagList(fileContent);

	// ^O̊JnEAq\Ȃǂǂݎďoオ
	result = Parse(pureTagList);

	// オ[
	return result;

}
//=========================================================
// ǂݍ
// ŏʗvf
// [gvfĂꍇ͂ĂԂƊyB
//=========================================================
NotXML::Tag NotXML::ReadRoot(string fileName) {

	/*
		Read() ɊۓāAʂԍŏ̗vfoĂ邾łB
	*/

	Tag result;

	vector<Tag> rootList = Read(fileName);

	if (rootList.size() > 0) {
		result = rootList[0];
	}

	return result;
}





//=========================================================
// t@Cǂݍŕɂ
//=========================================================
string NotXML::ReadFile_toString(string fileName) {

	string result = "";
	bool isFirstRow = true;

	std::ifstream ifs;
	
	ifs.open( fileName.c_str() );
	
	string row;
	while ( getline(ifs, row) ) {

		if (!isFirstRow) {
			result += '\n';
		}

		result += row;

		isFirstRow = false;
	}

	ifs.close();

	return result;
}

//=========================================================
// 񂩂^Oۂӏ𒊏o
//=========================================================
vector<string> NotXML::Parse_PureTagList(string str) {

	vector<string> result;

	string temp = "";

	for (unsigned int i = 0; i < str.size(); ++i) {

		char c = str[i];

		// ʂ̃^On܂Ȃ
		if (c == '<') {

			// ݂̏Ԃŕۑ
			if (temp != "") {
				result.push_back(temp);
				temp = "";
			}
		}

		temp += c;

		// ܂H
		if (c == '>') {

			// ݂̏Ԃŕۑ
			result.push_back(temp);
			temp = "";
		}

		/*
			t@Cɗ]͖̂łˁB
			ǂ̃^OĂȂlƂƂŁB
		*/
	}



	return result;
}

//=========================================================
// ^O̎ނ𔻕ʂ
//=========================================================
NotXML::PURE_TAG_TYPE NotXML::JadgePureTag( string pureTag ) {

	PURE_TAG_TYPE type = NOT_PURE_TAG_TYPE;

	/*
		EJn^O    FJnu<v   Au>vłB
		E^O    FJnu</v  Au>vłB
		EȊ^OFJnu<v   Au/>vłB
		ERg    FJnu<!--vAu-->vłB
		
		E    FJnu<?v       Au?>vłB
		EDOCTYPE錾 FJnu<!DOCTYPEvAu/>vłB

		El          Fu<v`u>vł͂Ȃ̕

		EȂłȂFJnu</v  Au/>vł
	*/
	do {
		///// RgH
		string commentStart = pureTag.substr(0, 4);
		string commentEnd   = (pureTag.size() < 3) ? "" : pureTag.substr( pureTag.size() - 3);
		if (commentStart == "<!--" && commentEnd == "-->") {
			type = COMMENT;
			break;
		}

		string closeTagStart  = pureTag.substr(0, 2);
		string nonValueTagEnd = (pureTag.size() < 2) ? "" : pureTag.substr( pureTag.size() - 2);

		///// Ȃ̂͂I
		if (closeTagStart == "</" && nonValueTagEnd == "/>") {
			type = NOT_PURE_TAG_TYPE;
			break;
		}

		string processStart = pureTag.substr(0, 2);
		string processEnd   = (pureTag.size() < 2) ? "" : pureTag.substr( pureTag.size() - 2);

		///// ߁H
		if (processStart == "<?" && processEnd == "?>") {
			type = PROCESS;
			break;
		}

		string docTypeStart = pureTag.substr(0, 9);

		///// DOCTYPE錾H
		if (docTypeStart == "<!DOCTYPE" && nonValueTagEnd == "/>") {
			type = DOCTYPE;
			break;
		}


		string nomalTagStart = pureTag.substr(0, 1);
		string nomalTagEnd   = (pureTag.size() < 1) ? "" : pureTag.substr( pureTag.size() - 1);

		///// Ȋ^OH
		if (nomalTagStart == "<" && nonValueTagEnd == "/>") {
			type = EMPTY;
			break;
		}

		///// ^OH
		if (closeTagStart == "</" && nomalTagEnd == ">") {
			type = CLOSE;
			break;
		}

		///// Jn^OH
		if (nomalTagStart == "<" && nomalTagEnd == ">") {
			type = OPEN;
			break;
		}

		///// lH
		if (type == NOT_PURE_TAG_TYPE) {
			type = VALUE;
		}

	} while(false);

	//printf("%sF%d\n", pureTag.c_str(), type);

	return type;
}


//=========================================================
// 
//=========================================================
map<string, string> NotXML::GetAttribute(string str) {

	map<string, string> result;

	// ݁AǂݎĂŒȂ̂H
	string currentParseMode;
	string PARSE_MODE_KEY   = "key";
	string PARSE_MOSE_VALUE = "value";
	currentParseMode = PARSE_MODE_KEY;

	unsigned int index = 0;
	string tempKey   = "";
	string tempValue = "";

	bool isStartedAddValue = false;

	while ( index < str.size() ) {

		///// L[ǂݎĂƂłB
		if ( currentParseMode == PARSE_MODE_KEY ) {
		
			// u=voAL[I
			if (str[index] == '=') {

				currentParseMode = PARSE_MOSE_VALUE;
				++index;
				continue;
			}

			// L[ɕǉĂ
			tempKey += str[index];

		
		///// lǂݎĂƂł
		} else if ( currentParseMode == PARSE_MOSE_VALUE ) {
		
			// ܂lɕǉn߂ĂȂ
			if (!isStartedAddValue) {

				// 󔒂Ȃ̂o
				if ( !isspace( str[index])) {

					isStartedAddValue = true;
				}
			}


			// lɕǉn߂ĂƂ
			if (isStartedAddValue) {
		
				// I̔B݂͒̕ǉẮH
				bool isAddCurrentChar = true;

				// NH[e[Vň͂ŏIH
				bool isEndByQuort = false;

				// I
				if ( tempValue.size() > 0 ) {

					// l̍ŏ̕ NH[e[Vłꍇ
					if ( tempValue[0] == '"' || tempValue[0] == '\'' ) {

						// NH[e[VꂽAlI
						if ( str[index] == '"' || str[index] == '\"' ) {

							// GXP[vĂ邩H
							bool isEscape = false;
							if ( tempValue.size() > 1 && tempValue[ tempValue.size() - 1] == '\\' ) {

								isEscape = true;

								// u\vLGXP[vĂ画͕B
								if ( tempValue.size() > 2 && tempValue[ tempValue.size() - 2] == '\\' ) {
									isEscape = false;
								} 
							}

							// GXP[vĂȂȂlI
							if (!isEscape) {

								currentParseMode  = PARSE_MODE_KEY;
								isStartedAddValue = false;
								isAddCurrentChar  = true;

								isEndByQuort = true;
							}
						}

					// l̍ŏ̕ NH[e[Vł͂Ȃꍇ
					} else {

						// 󔒂ꂽI
						if ( isspace( str[index] )  ) {
							currentParseMode  = PARSE_MODE_KEY;
							isStartedAddValue = false;
							isAddCurrentChar  = false;
						}

						// Ō܂ŒBĂĂI
						if ( index == str.size() - 1 ) {
							currentParseMode  = PARSE_MODE_KEY;
							isStartedAddValue = false;
							isAddCurrentChar  = true;
						}

					}

				} // if lǂݍ I

				// lɕǉĂ
				if (isAddCurrentChar) {
					tempValue += str[index];
				}

				// lǂݍ݂IĂꍇ
				if (currentParseMode != PARSE_MOSE_VALUE) {

					// l󔒂ȂȂAH
					if (tempValue != "") {

						// l̑ÕNH[e[VO
						if ( isEndByQuort) {
							tempValue = tempValue.substr( 1, tempValue.size() - 2 );


							// GXP[vLO
							/*
								\"  "
								\'  '
								\\  \

								\\"  HHH
								\\\  HHH

								܂蒆r[ɋC𗘂ȂH
								ȋCĂ܂B
								悵B܂B
							*/
						}

					}
					
					// L[̑O̓g
					tempKey = Trim( tempKey );


					// L[ƒl̃yA𑮐ɒǉ
					string key   = tempKey;
					string value = tempValue;

					result.insert( pair<string, string>( key, value ) );

					tempKey   = "";
					tempValue = "";
				}

			} // if lɕǉn߂ĂƂ
		}


		++index;
	};



	return result;
}

//=========================================================
// ^OƂĂ̏擾
//=========================================================
NotXML::Tag NotXML::GetTagInfo(string str, PURE_TAG_TYPE type) {

	Tag result;

	///// u<vu>vOg
	string content = "";

	// Jn^OłB<***>
	if        ( type == OPEN ) {

		content = str.substr(1, str.size() - 2);

	// ^OłB</***>
	} else if ( type == CLOSE ) {

		content = str.substr(2, str.size() - 3);

	// vf^OłB<***/>
	} else if ( type == EMPTY ) {

		content = str.substr(1, str.size() - 3);

	// ߃^OłB<?***?>
	} else if ( type == PROCESS ) {

		content = str.substr(2, str.size() - 4);

	// DOCTYPE錾łB<!DOCTYPE ***/>
	} else if ( type == DOCTYPE ) {

		content = str.substr(9, str.size() - 11);

		///// DOCTYPȄꍇ͓B
		result.name  = "";
		result.value = content;
		return result;
	}

	// ^OI_̃CfbNX
	int tagNameEndIndex = -1;

	// ^Oo
	for (unsigned int i = 0; i < content.size(); ++i) {

		// 󔒂ȂȂA^OƂĕǉĂ
		if (!isspace( content[i] )) {
			result.name += content[i];

		// 󔒂oꍇ
		} else {

			// łɃ^OFn߂ĂȂAI
			if (result.name != "") {

				// ^OI_̃CfbNXoĂB
				tagNameEndIndex = i;

				// I
				break;

			// ܂^OFn߂ĂȂȂAs
			} else {
				// s
			}
		}
	}

	// ^Oȍ~̕瑮o
	string attributeString = (tagNameEndIndex > 0) ?  content.substr( tagNameEndIndex ) : "";

	result.attribute = GetAttribute(attributeString);


	return result;
}

//=========================================================
// ^OԂ̍\
//=========================================================
vector<NotXML::Tag> NotXML::Parse(vector<string> pureTagList) {

	///// ^OXg
	vector<Tag> rootTagList;

	///// J̃^O
	stack<Tag> tagStack;

	for (unsigned int i = 0; i < pureTagList.size(); ++i) {

		string pureTag = pureTagList[i];


		// ނ
		PURE_TAG_TYPE type =  JadgePureTag( pureTag );


		// Jn^Oł
		if        ( type == OPEN ) {

			// ^O̖OƂ擾āA
			Tag tag =  GetTagInfo( pureTag, type);

			// X^bNɏ悹
			tagStack.push( tag );


		// ^Oł
		} else if ( type == CLOSE ) {

			// ^O̖OƂ擾
			Tag tag =  GetTagInfo( pureTag, type);

			// J̃^O܂ˁH
			if (tagStack.size() > 0 ) {

				// J̃^OƁAOvĂ܂ˁH
				if ( tagStack.top().name == tag.name ) {

					// ^OoāAB
					Tag closedTag = tagStack.top();
					tagStack.pop();

					// āAJ̃^O܂H
					if ( tagStack.size() > 0 ) {

						// J̃^O̎qvfƂĒǉ
						tagStack.top().childList.push_back( closedTag );

					} else {

						// ŏʃ^ÕXgɒǉ
						rootTagList.push_back( closedTag );
					}

				// AvĂȂ́H ͍܂ˁB
				} else {
					printf("^Oɑ΂āAJ̃^OȂF%s\n", pureTag.c_str());
				}


			// AȂ́H ͍܂ˁB
			} else {
				printf("^Oɑ΂āAJ̃^OȂF%s\n", pureTag.c_str());
			}


		// vf^Oł
		} else if ( type == EMPTY ) {

			// ^O̖OƂ擾āA
			Tag tag =  GetTagInfo( pureTag, type);

			// ꉞOėvfɂĂB
			tag.value = "";

			// J̃^O܂H
			if ( tagStack.size() > 0 ) {

				// JĂ^O̎qvfƂĒǉ
				tagStack.top().childList.push_back( tag );

			// J̃^OȂȂ΁A
			} else {

				// ŏʃ^ÕXgɒǉ
				rootTagList.push_back( tag );
			}

		// lł
		} else if ( type == VALUE ) {

			// J̃^O͂Ȃ̂łB
			if ( tagStack.size() > 0 ) {

				// ̎ɂ͕^O͂c
				tagStack.top().value += pureTag;

			// AJ̃^OȂ́H
			} else {
				//printf("J̃^OȂElF%s\n", pureTag.c_str());
			}


		// Rgł
		} else if ( type == COMMENT ) {

			// 

		// ߂ł
		} else if ( type == PROCESS ) {

			// Ă܂܂B

		// DOCTYPE錾ł
		} else if ( type == DOCTYPE ) {

			// Ă܂܂B


		// lł
		} else if ( type == NOT_PURE_TAG_TYPE ) {

			// 

		}
	}

	///// ^OXg
	rootTagList;

	///// J̃^O
	tagStack;


	return rootTagList;
}



//=========================================================
// Trim
//yz
// string
//y߂lz
// ÕzCgXy[X菜
//=========================================================
string NotXML::Trim(const string &str){

	if (str == "") {
		return "";
	}

	string result = "";

	unsigned int firstIndex = 0;
	unsigned int lastIndex = str.length() - 1;

	// Jnʒu
	while (true) {

		// S
		if ( firstIndex >= str.length() ) {
			return "";
		}

		// Ȃł́H
		if( str[firstIndex] == ' ' || str[firstIndex] == '\r' || str[firstIndex] == '\n' || str[firstIndex] == '\t'){
			++firstIndex;
		} else {
			break;
		}
	}

	// Iʒu
	while (true) {

		// ĂтȂł́H
		if( lastIndex > 0 && str[lastIndex] == ' ' || str[lastIndex] == '\r' || str[lastIndex] == '\n' || str[lastIndex] == '\t'){
			--lastIndex;
		} else {
			break;
		}
	}

	// JnʒuIʒu܂ło
	for ( unsigned int i = firstIndex; i <= lastIndex; ++i ) {
		result += str[i];
	}

	return result;
}
