//=========================================================
//
// Utils_Cal (declare)
//
//=========================================================


#ifndef _UTILS_CAL_
#define _UTILS_CAL_

#include <map>
#include <vector>
#include <string>
#include <set>

//#include <SFML/Window.hpp>
//#include <SFML/Graphics.hpp>

using namespace std;

class Utils_Cal {

public:

	//=========================================================
	// From -> To with the distance
	//=========================================================
	//static sf::Vector2f MoveTo ( sf::Vector2f from, sf::Vector2f to, float distance );
	static pair<float, float> MoveTo ( float from_x, float from_y, float to_x, float to_y, float distance );

	//=========================================================
	// Get Distance
	//=========================================================
	//static float GetDistance ( sf::Vector2f from, sf::Vector2f to );
	static float GetDistance ( float from_x, float from_y,  float to_x, float to_y);

	//=========================================================
	// Nearlize
	//=========================================================
	static float Nearlize( float from, float to, float distance );


	//=========================================================
	// ߂
	//=========================================================
	static int Sign( int a );

	//=========================================================
	// intpabs
	//=========================================================
	static unsigned int Abs( int a, int b );
	static unsigned int Abs( int a );

	//=========================================================
	// intppow
	// a^b
	//=========================================================
	static int Pow(int a, int b);

	//=========================================================
	// 
	//=========================================================
	static int GetRandom( int max );
	static int GerRandom( int max );

	//==========================================================
	// RCgX
	// lot / all łāA肪o true
	//==========================================================
	static bool MultipleCoinToss ( int lot, int all );

	//=========================================================
	// Permutation
	//yz
	// left o right
	//=========================================================
	static int Permutation ( int left, int right );

	//=========================================================
	// ϒŁAől`FbN
	//yz
	// argNum ̌u argNum ̐̒Łv
	//yʁz
	// ŏ̈őlAtrue
	//=========================================================
	static bool Utils_Cal::IsMax ( int argNum, ... );

	//=========================================================
	// dȂŗ
	//=========================================================
	static void GetRandom_WithoutDuplicate ( set<int> &result, unsigned int n, int min, int max );

	//==========================================================
	// ԂɓĂ
	// ^܂ނǂ true Ŋ܂
	//==========================================================
	static bool IsBetween( int thisValue, int a, int b, bool isOverIncluded );

	//=========================================================
	// ȎľܓƂlɊۂ߂
	//=========================================================
	static void RoundWildly ( float & value );
};
#endif