//=========================================================
//
// ֌W̃Tu[`Wi錾j
//
//=========================================================

#include "StdAfx.h"
#include <Windows.h>
#include <string>
#include <vector>
#include <map>
//#include "Utils.h"
#include "Utils_String.h"

using namespace std;

//=========================================================
// OTrim
//yz
// string
//y߂lz
// O̔pXy[XA\nA\r菜
//=========================================================
string Utils_String::Trim(string str){

	string result = "";

	int firstIndex = 0;
	int lastIndex = str.length() - 1;

	// Jnʒu
	while(true){

		// SXy[Xors
		if(firstIndex == str.length()){
			return "";
		}

		if(str[firstIndex] == ' ' || str[firstIndex] == '\r' || str[firstIndex] == '\n' || str[firstIndex] == '\t'){
			++firstIndex;
		} else {
			break;
		}
	}

	// Iʒu
	while(true){

		if(str[lastIndex] == ' ' || str[lastIndex] == '\r' || str[lastIndex] == '\n' || str[lastIndex] == '\t'){
			--lastIndex;
		} else {
			break;
		}
	}

	// JnʒuIʒu܂ło
	for(int i = firstIndex; i <= lastIndex; ++i){
		result += str[i];
	}

	return result;
}

//=========================================================
// OSplit
//yz
// string value   : Ώۂ̕
// string spliter : ؂蕶
//y߂lz
// vector<string>
//=========================================================
vector<string> Utils_String::Split(string value, string spliter){

	vector<string> result;


	int splitterLength = spliter.length();
	char *splitterChar = (char*)spliter.c_str();

	int currentPosition = 0;
	int bufa = 0;

	char *pStr = (char*)value.c_str();
	while(*pStr != '\0'){

		// ݒnXvb^[̕擾
		string now = pStr;
		string splitterCandidate = now.substr(0, splitterLength);

		// Xvb^[Ɉvꍇ
		if(splitterCandidate == splitterChar){

			// obt@A擾ČʃXgɎ߂
			result.push_back(value.substr(currentPosition, bufa));

			// ݒni߂
			currentPosition += bufa + splitterLength;
			pStr += splitterLength;

			// obt@NA
			bufa = 0;


		// vȂꍇ
		} else {

			// obt@ɑ
			bufa += strlen(pStr) - strlen(CharNext(pStr));

			// i߂
			pStr = CharNext(pStr);
		}

	}

	// ]ʃXgɒǉ
	result.push_back(value.substr(currentPosition, bufa));

	return result;
}

//=========================================================
// woCgƂɋ؂Xg擾
//yz
// string str  : ̕
// int    byte : ̃oCgŋ؂
//y߂lz
// vector<string>
//=========================================================
vector<string> Utils_String::SplitByByte(string value, int byte){

	vector<string> result;

	int currentPosition = 0;

	while( true ){

		// ͂ݏoƂ́A
		if((currentPosition + byte) >= value.length()){

			// c̕SďI
			result.push_back(
				value.substr(currentPosition)
			);
			break;
		}

		// 傤ǏIƂ
		if(currentPosition == (value.length() - 1)){

			// I
			break;
		}

		// 擾
		result.push_back(
			value.substr(currentPosition, byte)
		);

		// i߂
		currentPosition += byte;
	}
	return result;
}

//=========================================================
// m\񂩂ǂB
//y߂lz
// true  m\łB
//=========================================================
bool Utils_String::isPositiveWord(string arg) {

	bool result = (
		arg == "true" || 
		arg == "ok" || 
		arg == "on" || 
		arg == "yes" || 
		arg == "TRUE" || 
		arg == "ON" || 
		arg == "OK" || 
		arg == "YES"
	);

	return result;
}

//=========================================================
// ے\񂩂ǂB
//y߂lz
// true  ے\łB
//=========================================================
bool Utils_String::isNegativeWord(string arg) {

	bool result = (
		arg == "false" || 
		arg == "cancel" || 
		arg == "off" || 
		arg == "no" || 
		arg == "FALSE" || 
		arg == "OFF" || 
		arg == "CANCEL" || 
		arg == "NO"
	);

	return result;
}
//=========================================================
// vector<string>̒Ɏw̗vf邩H
//=========================================================
bool Utils_String::isContain(vector<string> list, string element) {

	bool result = false;

	vector<string>::iterator it = list.begin();
	while (it != list.end()) {

		if (element == (*it)) {
			result = true;
			break;
		}

		++it;
	}

	return result;
}
//=========================================================
// 񒆂Ɏw̃p^[܂܂Ă邩ǂ
//y߂lz
// true  ܂܂ĂB
//=========================================================
bool Utils_String::IsContainsPattern(string dest, string pattern){

	return Split(dest, pattern).size() >= 2;

}


//=========================================================
// ֑w̃oCgŉsB
//=========================================================
vector<string> Utils_String::SplitByByte_Hyphenation(string str, int byte) {

	vector<string> result;

	string row = "";
	int currentIndex = 0;
	int rowStride    = 0;

	///// ꕶi߂Ă܂B
	char *currentPoint = (char*)str.c_str();
    while(*currentPoint != '\0')
    {

		///// ̕ւ̃|C^擾
		char *nextPoint = CharNext(currentPoint);

		///// ݒn̕B
		int stride = abs(nextPoint - currentPoint);

		///// 𑫂łāAƂsubstrɎgB
		rowStride += stride;

		///// 낻sł傤H
		bool isTab = false;

		///// Ō܂ōsĂsƂAʂɓB
		if (*nextPoint == '\0') {
			isTab = true;

		///// w肳Ăs̃oCgzĂsH
		} else if (rowStride >= byte) {

			///// ֑̂߂ɁAɎ̕܂B
			char *nextNextPoint = CharNext(nextPoint);

			///// ̕A擾܂āA
			string nextChar = str.substr(
				currentIndex + rowStride,
				abs(nextNextPoint - nextPoint)
			);

			///// ֑̑ΏەłȂΉs܂B
			if (!isHypenationChar(nextChar)) 
			{
				isTab = true;
			}
			

		}

		///// s邱ƂɂȂ̂ŁA܂ł̕؂oČʃXgɓB
		if (isTab) {

			row = str.substr(currentIndex, rowStride);
			currentIndex += rowStride;

			result.push_back(row);
			rowStride = 0;
			row       = "";
		}

		///// i݂܂[B
		currentPoint = nextPoint;
    }

	return result;
}

//=========================================================
// sȂ֑ł邩ǂ
//yz
// ꕶłƊҁB
//y߂lz
// sȂł true
//=========================================================
bool Utils_String::isHypenationChar(string str) {

	bool result = (
				   str != "B"
				&& str != "A"
				&& str != ","
				&& str != "."
				&& str != "I"
				&& str != "H"
				&& str != "!"
				&& str != "?"
				&& str != ")"
				&& str != "j"
				&& str != "]"
				&& str != "v"
				&& str != "}"
				&& str != ""
				&& str != "b"
				&& str != "-"
				&& str != "["
				&& str != " "
			);


	return !result;
}

//=========================================================
// p啶Sďɂ
//=========================================================
string Utils_String::toLowerString(string str) {

	/*
		Spɂ͑ΉĂ܂ʁB

		t@Cϊ邽߂Ɏĝł΁A
		t@Cɂ͑SpgȂ܂ŁB
	*/

	string result = "";

	for (unsigned int i = 0; i < str.size(); ++i) {

		char c = str[i];

		if        (c == 'A') { c = 'a';
		} else if (c == 'B') { c = 'b';
		} else if (c == 'C') { c = 'c';
		} else if (c == 'D') { c = 'd';
		} else if (c == 'E') { c = 'e';
		} else if (c == 'F') { c = 'f';
		} else if (c == 'G') { c = 'g';
		} else if (c == 'H') { c = 'h';
		} else if (c == 'I') { c = 'i';
		} else if (c == 'J') { c = 'j';
		} else if (c == 'K') { c = 'k';
		} else if (c == 'L') { c = 'l';
		} else if (c == 'M') { c = 'm';
		} else if (c == 'N') { c = 'n';
		} else if (c == 'O') { c = 'o';
		} else if (c == 'P') { c = 'p';
		} else if (c == 'Q') { c = 'q';
		} else if (c == 'R') { c = 'r';
		} else if (c == 'S') { c = 's';
		} else if (c == 'T') { c = 't';
		} else if (c == 'U') { c = 'u';
		} else if (c == 'V') { c = 'v';
		} else if (c == 'W') { c = 'w';
		} else if (c == 'X') { c = 'x';
		} else if (c == 'Y') { c = 'y';
		} else if (c == 'Z') { c = 'z';
		}

		result += c;

	}

	return result;
}

//=========================================================
// t@CL[XgtB^[ʂĎ擾
//yz
// string t@CƂēnĂB
//=========================================================
string Utils_String::GetFileNameThroughFilter(string fileNameOrKey, map<string, string> &fileNameKeyList) {

	///// A[JCuǂ񂾂Ƃ΍ŃgB
	fileNameOrKey = Trim(fileNameOrKey);

	string result = fileNameOrKey;

	///// PڂƍŏIm
	char firstChar = (fileNameOrKey != "" && fileNameOrKey.length() > 0)?fileNameOrKey.c_str()[0]:NULL;
	char lastChar  = (fileNameOrKey != "" && fileNameOrKey.length() > 0)?fileNameOrKey.c_str()[fileNameOrKey.length() - 1]:NULL;

	///// L[ǂ
	if(firstChar == '[' && lastChar == ']'){

		///// L[o
		string key = "";
		for(int i = 1; i < fileNameOrKey.length() - 1; ++i){
			key += fileNameOrKey.c_str()[i];
		}

		///// L[邩ǂ
		if(fileNameKeyList.find(key) != fileNameKeyList.end()){
			result = fileNameKeyList.find(key)->second;
		} else {
			result = "";
		}


	} else {

		///// L[Ȃ̂ł̂܂܃t@CƂ
		result = fileNameOrKey;
	}

	return result;
}